<template>
  <v-list
    class="p-0 bg-transparent text-white overflow-x-hidden"
    activatable
    mandatory
  >
    <v-list-item
      v-for="route in menuRoutes"
      :key="route.path"
      :active="getIsRouteActive(route.path)"
      :class="{ 'active-route before:bg-gray-100': markers && getIsRouteActive(route.path) }"
      class="py-4"
      @click="router.push(route.path)"
    >
      <template #prepend>
        <v-icon
          :icon="route.meta.icon"
          size="large"
        />
      </template>

      <v-list-item-title class="text-lg">
        {{ route.meta.title }}
      </v-list-item-title>
    </v-list-item>
  </v-list>
</template>

<script setup lang="ts">
import { useRouter } from 'vue-router';
import { routes } from '@/router/routes.ts';

type MenuRoute = {
  path: string,
  meta: {
    title: string,
    navigational: boolean,
    icon: string,
  },
}

withDefaults(defineProps<{ markers?: boolean }>(), {
  markers: true,
});

const router = useRouter();

const menuRoutes = <MenuRoute[]><unknown>(
  routes.filter(route => route?.meta?.navigational)
);

const getIsRouteActive = (path: string) => {
  return router.currentRoute.value.path === path;
};
</script>

<style scoped>
@keyframes slidein {
  0% { transform: translate(125%, -50%) rotate(45deg); }
  100% { transform: translate(50%, -50%) rotate(45deg); }
}

.active-route::before {
  position: absolute;
  width: 1.1rem;
  height: 1.1rem;
  top: 50%;
  right: 0;
  transform: translate(50%, -50%) rotate(45deg);
  animation: slidein .3s 1 alternate ease;
}
</style>